# -*- coding: utf-8 -*-

# Copyright 2023, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import collections

LicenseInfo = collections.namedtuple("LicenseInfo", ["worker", "twowop"])


try:
    # The module _packagemanager exists from Epic ID-1414 (interiorcad 2024 F2.0?) on
    import _packagemanager

    def getLicenseInfo():
        return LicenseInfo(_packagemanager.isAtLeastPackageWorker(), _packagemanager.has2WOP())

except ImportError:

    def getLicenseInfo():
        return None
