# -*- coding: utf-8 -*-

# Copyright 2011-2014, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import collections

import interiorcad.backend.datatracker.datatracker


ProjectPosition = collections.namedtuple("ProjectPosition", "name description quantity")


def generateProjectPositions(documentUUID):
    interiorcad.backend.datatracker.datatracker.beginConsuming()
    numPositions = interiorcad.backend.datatracker.datatracker.getItemAsLong(documentUUID, 0, 'jobp_numpositions')
    for i in range(numPositions):
        yield ProjectPosition(
            name=interiorcad.backend.datatracker.datatracker.getItemAsString(documentUUID, 0, 'jobp_positionname_{index}'.format(index=i)),
            description=interiorcad.backend.datatracker.datatracker.getItemAsString(documentUUID, 0, 'jobp_positiondesciption_{index}'.format(index=i)),
            quantity=interiorcad.backend.datatracker.datatracker.getItemAsString(documentUUID, 0, 'jobp_positionquantity_{index}'.format(index=i)),
        )
    interiorcad.backend.datatracker.datatracker.endConsuming()


def getDescriptionAndQuantityOfProjectPositionNamed(documentUUID, positionName):
    for name, description, quantity in generateProjectPositions(documentUUID):
        if name == positionName:
            break
    else:
        description = ""
        quantity = ""
    return description, quantity
