# -*- coding: utf-8 -*-

# Copyright 2011-2015, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import sys

try:
    import _interiorcadinternals

    # See http://docs.python.org/py3k/faq/extending.html
    class StdRedirect:
        def __init__(self, filename):
            self.ourErrorFile = open(filename, "wt", encoding="utf-8")

        def write(self, data):
            self.ourErrorFile.write(data)

        def flush(self):
            self.ourErrorFile.flush()

        def close(self):
            self.ourErrorFile.close()

        def __del__(self):
            self.ourErrorFile.close()

    sys.stdout = StdRedirect(_interiorcadinternals.getPathOfStdOutRedirectionFile())
    sys.stderr = StdRedirect(_interiorcadinternals.getPathOfStdErrRedirectionFile())

except ImportError:
    pass
