# -*- coding: utf-8 -*-

# Copyright 2011-2014, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import unittest

from interiorcad.interface.geometry.point import Point
from interiorcad.interface.geometry.vertex import Vertex


class NCLineSegment:
    def __init__(self, startPt=0, endPt=0):
        self.startVertex = startPt
        self.endVertex = endPt

    def isLineSegment(self):
        return True

    def getStartVertex(self):
        return self.startVertex

    def getEndVertex(self):
        return self.endVertex

    def __eq__(self, rhs):
        return all((
            rhs is not None,
            self.startVertex == rhs.startVertex,
            self.endVertex == rhs.endVertex,
        ))

    def __repr__(self):
        return "NCLineSegment(startPt={}, endPt={})".format(self.startVertex, self.endVertex)


class NCLineSegmentTest(unittest.TestCase):
    def testLinesShoulBeEqual(self):
        startPt = Vertex(Point(100.0, 100.0))
        endPt = Vertex(Point(100.0, 100.0))
        segment1 = NCLineSegment(startPt, endPt)
        segment2 = NCLineSegment(startPt, endPt)
        self.assertTrue(segment1 == segment2)
        self.assertEqual(segment1, segment2)
