# -*- coding: utf-8 -*-

# Copyright 2011-2016, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


try:
    import _interiorcadopenservices  # @UnusedImport

    def openPath(path):
        if hasattr(_interiorcadopenservices, 'openPath'):  # Available only from interiorcad 2016 F3 on
            _interiorcadopenservices.openPath(path)
        elif hasattr(_interiorcadopenservices, 'openExportPath'):  # Old name of function (up to interiorcad 2016 F2)
            _interiorcadopenservices.openExportPath(path)

    def openFile(filename):
        if hasattr(_interiorcadopenservices, 'openFile'):  # Available only from interiorcad 2016 F3 on
            _interiorcadopenservices.openFile(filename)


except ImportError:
    import sys
    import os
    import logging

    def openPath(path):
        if "XGSUPPRESSOPENINGOFWINDOWS" in os.environ:
            logging.info("Opening of folder %s suppressed", path)
        elif sys.platform == "win32":
            os.startfile(path)
        else:
            import webbrowser
            webbrowser.open('file://' + path)

    def openFile(filename):
        if "XGSUPPRESSOPENINGOFWINDOWS" in os.environ:
            logging.info("Opening of file %s suppressed", filename)
        elif sys.platform == "win32":
            os.startfile(filename)
        else:
            import webbrowser
            webbrowser.open('file://' + filename)


# Old name of function (up to interiorcad 2016 F2). Kept for source compatibility reasons.
def openExportPath(path):
    openPath(path)
