# -*- coding: utf-8 -*-

# Copyright 2016-2021, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


import logging

from interiorcad.backend.localization import getLocalizedString, NCEXPORT_MESSAGES_RESOURCEGROUP
from interiorcad.interface.surface.chamfer2d import Chamfer2D


class ChamferWarner:
    def process(self, surface):
        if any(map(lambda machining: isinstance(machining, Chamfer2D), surface.machinings)):
            message = getLocalizedString(NCEXPORT_MESSAGES_RESOURCEGROUP, 60, "Chamfers are not supported. Workpiece {workpiece}")
            logging.warning(message.format(workpiece=surface.workpieceName))
