# -*- coding: utf-8 -*-

# Copyright 2019, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


class ToolExportMachiningsFilter:
    def process(self, surface):
        # We do not care about Sizing here, SizingToolFilter will do it later for us.
        validMachinings = [machining for machining in self.filterMachinings(surface.machinings)]
        surface.machinings = validMachinings

    def filterMachinings(self, machinings):
        for machining in machinings:
            if not hasattr(machining, 'tool') or not machining.tool or machining.tool.exportMachinings:
                yield machining
