# -*- coding: utf-8 -*-

# Copyright 2011-2017, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.backend.workpiececreationstrategy.constants import SizingMode


class SizingCreator:
    def __init__(self, workpieceReader, sizingaddition):
        self.workpieceReader = workpieceReader
        self.sizingaddition = sizingaddition

    def getSizingAndItsBounds(self, sizingMode):
        sizing = None
        sizingBounds = None
        if sizingMode == SizingMode.JOINT_SIZING:
            sizing = self.getJointSizing()
            sizingBounds = self.getJointSizingBounds()
        elif sizingMode == SizingMode.DEFAULT_SIZING:
            sizing = self.getDefaultSizing()
            sizingBounds = self.getDefaultSizingBounds()
        elif sizingMode == SizingMode.PRELIMINARY_SIZING:
            sizing = self.getPreliminaryRectangularSizing()
            sizingBounds = self.getPreliminaryRectangularSizingBounds()
        elif sizingMode == SizingMode.PRELIMINARY_JOINT_SIZING:
            sizing = self.getPreliminaryJointingRectangularSizing()
            sizingBounds = self.getPreliminaryJointingRectangularSizingBounds()
        return sizing, sizingBounds

    def getDefaultSizing(self):
        return self.workpieceReader.getSawnSizeSizing()

    def getDefaultSizingBounds(self):
        return self.workpieceReader.getSawnSizingBoundsFromWorkpiece()

    def getPreliminaryRectangularSizingBounds(self):
        return self.workpieceReader.getPreliminaryRectangularSizingBounds(self.sizingaddition)

    def getPreliminaryRectangularSizing(self):
        return self.workpieceReader.getPreliminaryRectangularSizing(self.sizingaddition)

    def getJointSizingBounds(self):
        return self.workpieceReader.getJointingSizingBoundsFromWorkpiece()

    def getJointSizing(self):
        return self.workpieceReader.getJointingSizeSizing()

    def getPreliminaryJointingRectangularSizingBounds(self):
        return self.workpieceReader.getPreliminaryJointingRectangularSizingBounds(self.sizingaddition)

    def getPreliminaryJointingRectangularSizing(self):
        return self.workpieceReader.getPreliminaryJointingRectangularSizing(self.sizingaddition)
