# -*- coding: utf-8 -*-

# Copyright 2011-2022, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.interface.geometry.point import Point
from interiorcad.interface.geometry.rectangle import Rectangle


class SurfaceDimension:
    def __init__(self):
        self.size = Point()
        self.additionForEdges = Rectangle()
        self.sizingAddition = 0
        self.jointSizeAddition = Point(0, 0)

    def getLength(self):
        return self.size.x + self.sizingAddition * 2

    def getWidth(self):
        return self.size.y + self.sizingAddition * 2

    def rotateRight(self):
        self.size.x, self.size.y = self.size.y, self.size.x
        self.additionForEdges.rotateRightAtZeroNoNegation()
        self.jointSizeAddition.x, self.jointSizeAddition.y = self.jointSizeAddition.y, self.jointSizeAddition.x
