# -*- coding: utf-8 -*-

# Copyright 2011-2015, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


class SurfaceSizing:
    def __init__(self):
        self.sizing = None
        self.sizingBounds = None


class SurfaceSizingCreator:
    def __init__(self, strategy, sizingCreator, sideDecider):
        self.strategy = strategy
        self.sizingCreator = sizingCreator
        self.sideDecider = sideDecider

    def createAny(self, sizingMode):
        surface = SurfaceSizing()
        surface.sizing, surface.sizingBounds = self.sizingCreator.getSizingAndItsBounds(sizingMode)
        return surface

    def createMain(self):
        return self.createAny(self.strategy.getMainSizingMode(needsOpposite=self.sideDecider.needsOpposite()))

    def createOpposite(self):
        return self.createAny(self.strategy.getOppositeSizingMode(needsMain=self.sideDecider.needsMain()))

    def createSizing(self):
        return self.createAny(self.strategy.getSizingSizingMode())
