# -*- coding: utf-8 -*-

# Copyright 2015-2017, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


try:
    import _interiorcadsystemlocale

    class SystemLocale:
        @staticmethod
        def getDecimalSeparator():
            # On purpose we do not use a dot(.), as it is the default in C/C++/Python. Also our main target clients are Germans for now.
            return _interiorcadsystemlocale.getDecimalSeparator()

        @staticmethod
        def getFieldSeparator():
            if hasattr(_interiorcadsystemlocale, 'getFieldSeparator'):
                return _interiorcadsystemlocale.getFieldSeparator()
            elif _interiorcadsystemlocale.getDecimalSeparator() == ',':
                return ';'
            else:
                return ','

except ImportError:
    class SystemLocale:
        @staticmethod
        def getDecimalSeparator():
            # On purpose we do not use a dot(.), as it is the default in C/C++/Python. Also our main target clients are Germans for now.
            return ','

        @staticmethod
        def getFieldSeparator():
            return ';'
