# -*- coding: utf-8 -*-

# Copyright 2017, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import unittest


class UmlautsCleaner:
    def __init__(self):
        self.map = {'\xe4': 'a', '\xf6': 'o', '\xfc': 'u', '\xc4': 'A', '\xd6': 'O', '\xdc': 'U', '\xdf': 's'}

    def clean(self, string):
        return string.translate(str.maketrans(self.map))


class UmlautsCleanerTests(unittest.TestCase):
    def testReplaceUmlautsWithConsonants(self):
        cleaner = UmlautsCleaner()
        self.assertEqual('aouAOU', cleaner.clean('\xe4\xf6\xfc\xc4\xd6\xdc'))

    def testReplaceSpecialSWithNormalS(self):
        cleaner = UmlautsCleaner()
        self.assertEqual('s', cleaner.clean('\xdf'))

    def testGreekCapitalLetterAlphaShouldBeKept(self):
        cleaner = UmlautsCleaner()
        self.assertEqual('\u0391', cleaner.clean('\u0391'))
