# -*- coding: utf-8 -*-

# Copyright 2011-2022, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import collections

from interiorcad.backend.workpiece.machining import Machining
from interiorcad.interface.geometry.point import Point

GridPointsCoordinateSystem = collections.namedtuple('GridPointsCoordinateSystem', ('xaxis',  'yaxis', 'origin'))


class ComplexGridDrilling(Machining):
    def __init__(self, uuid=''):
        super().__init__(uuid)
        self.diameter = 0
        self.depth = 0
        self.gridPoints = []
        self.gridPointsCoordinateSystem = GridPointsCoordinateSystem(
            xaxis=Point(1.0, 0.0),
            yaxis=Point(0.0, 1.0),
            origin=Point(0.0, 0.0),
        )
        self.drillThrough = False
