# -*- coding: utf-8 -*-

# Copyright 2016-2018, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import logging

from interiorcad.backend.localization import getLocalizedString, NCEXPORT_MESSAGES_RESOURCEGROUP


class InvalidPathWorkpieceFilter:
    def filterWorkpiece(self, workpiece):
        message = None

        if workpiece.finishedSizeBounds.isDegenerated():
            message = getLocalizedString(NCEXPORT_MESSAGES_RESOURCEGROUP, 56, "Suppressing workpiece '{workpiece}' because it has an invalid bounding size. (Current: {bounds})")

        if message:
            logging.warning(message.format(workpiece=workpiece.name, bounds=workpiece.finishedSizeBounds))

        return not bool(message)
