# -*- coding: utf-8 -*-

# Copyright 2016-2022, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import itertools

from interiorcad.backend.workpiece.nullmachining import NullMachining


class NullMachiningFilter:
    def filterWorkpiece(self, workpiece):
        workpiece.machinings = itertools.filterfalse(lambda machining: isinstance(machining, NullMachining), workpiece.machinings)

        return True  # The workpiece should never be discarded. (Another filter takes care of workpiece without machinings)
