# -*- coding: utf-8 -*-

# Copyright 2011-2014, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


import logging
import time


class SingleTimer:
    def __init__(self, name):
        self.name = name
        self.startTime = time.clock()
        self.elapsedTime = 0

    def stop(self):
        self.elapsedTime = time.clock() - self.startTime


class XGTimer:
    stoppedTimer = []

    @staticmethod
    def start(timerName):
        return SingleTimer(timerName)

    @staticmethod
    def stop(timer):
        timer.stop()
        XGTimer.stoppedTimer.append(timer)

    @staticmethod
    def report():
        if len(XGTimer.stoppedTimer) > 0:
            timerReports = ['{} took {}s'.format(timer.name, timer.elapsedTime) for timer in XGTimer.stoppedTimer]
            completeReport = 'XGTimer Report:\n\t' + '\n\t'.join(timerReports)
            logging.info(completeReport)
        XGTimer.stoppedTimer = []
