# -*- coding: utf-8 -*-

# Copyright 2015-2017, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import os.path

from interiorcad.cuttinglistexport.csvbase import CuttinglistExportCSVBase
from interiorcad.backend.localization import getLocalizedString, CUTTINGLIST_OUTPUT_FILE_NAMES_RESOURCEGROUP


class HomagProductionlistExport(CuttinglistExportCSVBase):
    EXPORT_FORMAT = os.path.splitext(getLocalizedString(CUTTINGLIST_OUTPUT_FILE_NAMES_RESOURCEGROUP, 8, "Produktionsliste.lis"))[0]

    def __init__(self, **keywords):
        super().__init__(**keywords)
        self.csvdelimiter = ','
        self.counter = 0

        self.EXTENSION = 'lis'

    def getDecimalSeparator(self, **keywords):
        return '.'

    def writeListHeader(self, **keywords):
        rows = (
            ('Mode=0',),
            ('VARS=0',),
        )
        self.writeRows(rows=rows, **keywords)

    def getEntriesForProductionList(self, **keywords):
        for entry in keywords['entries']:
            yield entry, entry.ncProgramPathSizing
            yield entry, entry.ncProgramPathMain
            yield entry, entry.ncProgramPathOpposite

    def getUnsortedElements(self, **keywords):
        return (self.getElements(ncProgramName=ncProgramName, entry=entry, workpiece=entry.workpiece, positionInfo=entry.positionInfo, **keywords) for entry, ncProgramName in self.getEntriesForProductionList(**keywords))

    def getElements(self, **keywords):
        placeNumber = 1
        placeMode = 0
        entry = keywords['entry']

        if keywords['ncProgramName']:
            self.counter += 1
            return (
                self.asInt(data=self.counter, **keywords),
                self.asString(data=keywords['ncProgramName'], **keywords),
                placeNumber,
                placeMode,
                self.asInt(data=entry.count, **keywords),
                '0',
                self.asString(data=entry.name, **keywords),
                '0',
                '',
                '',
                '',
                '',
                '',
                '',
                '',
                '',
                '',
                '',
                '',
            )
