# -*- coding: utf-8 -*-

# Copyright 2011-2019, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.interface.geometry.vertex import Vertex


class CornerVertex(Vertex):
    def __init__(self, position=None, visible=True):
        super().__init__(position, visible)

    def isCornerVertex(self):
        return True

    def isRadiusVertex(self):
        return False

    @property
    def type(self):
        return Vertex.CORNER_VERTEX

    @property
    def radius(self):
        return 0  # The radius of a corner vertex is always 0

    def __str__(self):
        return ' '.join((
            'CornerVertex:',
            super().__str__() + ';',
        ))
