# -*- coding: utf-8 -*-

# Copyright 2011-2019, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.backend.utilities.stringconcatenation import joinIfNotNone
from interiorcad.interface.machiningsexporter.machiningsneedingmanualinterventionexporter import MachiningsNeedingManualInterventionExporter


class ContoursExporter(MachiningsNeedingManualInterventionExporter):
    def __init__(self, export):
        super().__init__()
        self.export = export

    def createMachinings(self, **keywords):
        lines = joinIfNotNone('', *(self.exportMachining(machining, **keywords) for machining in self.getMachinings(**keywords)))
        return lines if lines is not None else ''

    def areConditionsRelevantForAStop(self, **keywords):
        surface = keywords['surface']
        return bool(surface.contoursVertical)

    def createStop(self, **keywords):
        return self.export.stopForInspectingContours(**keywords)

    def getMachinings(self, **keywords):
        return keywords['surface'].contoursVertical

    def exportMachining(self, machining, **keywords):
        return self.export.createVerticalContourBase(contour=machining, **keywords)
