# -*- coding: utf-8 -*-

# Copyright 2011-2023, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.interface.ncexport.generalexporter import GeneralExporter


class NestingExport(GeneralExporter):
    # TODO IT-294 Currently this class is not tested  --mjk
    def exportWorkpieceSurfaces(self, workpiece, surfaceCreator, programNamesHandler):
        surfaces = surfaceCreator.createSurfaces()

        self.hasMainSide = surfaces.hasMain()
        self.hasOppositeSide = surfaces.hasOpposite()

        if surfaces.hasSizing():
            message = self.ncexport.getLocalizedMessage(57, "Separate sizing is not allowed for nesting exports. Workpiece: {workpiece}").format(workpiece=workpiece.name)
            raise RuntimeError(message)

        nestable = True

        if surfaces.hasMain():
            self.createMainSide(surfaces.main, programNamesHandler, nestable=nestable)
            nestable = False

        if surfaces.hasOpposite():
            self.createOppositeSide(surfaces.opposite, programNamesHandler, nestable=nestable)
