# -*- coding: utf-8 -*-

# Copyright 2011-2020, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

import copy

from interiorcad.interface.geometry import isNearlyLesser
from interiorcad.interface.machineconfiguration import machineconfigurationkeys


def getVerticalActualDepth(boardThickness, depth, addition):
    if isNearlyLesser(depth, boardThickness):
        return copy.copy(depth)
    else:
        return boardThickness + addition


def getVerticalMillingActualDepth(machineConfiguration, boardThickness, depth):
    return getVerticalActualDepth(boardThickness, depth, machineConfiguration.getAsFloat(machineconfigurationkeys.SIZING_DEPTH_ADJUSTMENT_KEY, 3.0))


def getVerticalPocketActualDepth(machineConfiguration, boardThickness, depth):
    return getVerticalActualDepth(boardThickness, depth, machineConfiguration.getAsFloat(machineconfigurationkeys.PIERCING_POCKET_ADDITION_KEY, 3.0))


def getVerticalDrillingActualDepth(machineConfiguration, boardThickness, depth):
    return getVerticalActualDepth(boardThickness, depth, machineConfiguration.getAsFloat(machineconfigurationkeys.PIERCING_DRILLING_ADDITION_KEY, 2.0))
