# -*- coding: utf-8 -*-

# Copyright 2015-2022, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.interface.geometry.vector import Vector
from interiorcad.interface.surface.exportmethodnames import ExportKeys
from interiorcad.interface.surface.machining2d import Machining2D


class ComplexGridDrilling2D(Machining2D):
    def readFrom(self, machining3D):
        super().readFrom(machining3D)
        self.diameter = machining3D.diameter
        self.depth = machining3D.depth
        self.gridPoints = machining3D.gridPoints
        self.gridPointsCoordinateSystem = machining3D.gridPointsCoordinateSystem
        self.drillThrough = machining3D.drillThrough

    def assignTool(self, _surface, machineConfiguration):
        raise NotImplementedError

    def isAlongXAxis(self):
        return self.matrix.u == Vector(1.0, 0.0, 0.0) or self.matrix.u == Vector(-1.0, 0.0, 0.0)

    def isAlongYAxis(self):
        return self.matrix.u == Vector(0.0, 1.0, 0.0) or self.matrix.u == Vector(0.0, -1.0, 0.0)

    def getExportKey(self):
        return ExportKeys.GRIDDRILLING
