# -*- coding: utf-8 -*-

# Copyright 2011-2018, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH


class LineMachiningOrienter:
    def __init__(self, finalFinishedSizeShape):
        self.finalFinishedSizeShape = finalFinishedSizeShape

    def __getSegmentDirectionVector(self, segment):
        directionVectorSegment = segment.end.position - segment.start.position
        directionVectorSegment.normalize()
        return directionVectorSegment

    def __orientToNeededDirection(self, machining2D, directionVector):
        directionVectorSegment = self.__getSegmentDirectionVector(machining2D.segment)
        if directionVectorSegment == directionVector:
            machining2D.invert()

    def orientToCCW(self, machining2D):
        self.__orientToNeededDirection(machining2D, machining2D.directionVector)

    def orientToCW(self, machining2D):
        self.__orientToNeededDirection(machining2D, -machining2D.directionVector)

    def hasSegment(self, machining2D):
        return hasattr(machining2D, 'segment') and machining2D.segment

    @staticmethod
    def orient(machinings, adjusterFunction):
        tuple(map(adjusterFunction, machinings))
