# -*- coding: utf-8 -*-

# Copyright 2011-2021, extragroup GmbH, Pottkamp 19, 48149 Münster, Germany
# All rights reserved
#
# All information contained herein is, and remains the property of
# extragroup GmbH and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to extragroup GmbH
# and its suppliers and are protected by trade secret or copyright law.
# Dissemination of this information or reproduction of this material is
# strictly forbidden unless prior written permission is obtained from
# extragroup GmbH

from interiorcad.interface.surface.exportmethodnames import ExportKeys
from interiorcad.interface.surface.machining2d import Machining2D


class NullMachining2D(Machining2D):
    def assignTool(self, _surface, _machineConfiguration):
        self.tool = None   # A null machining has never a tool
        self.assignToolIDFromTool()

    def getExportKey(self):
        return ExportKeys.NULL_MACHINING

    def __str__(self):
        result = ' '.join((
            'NullMachining 2D:',
            super().__str__() + ";",
        ))
        return result

    def __repr__(self):
        return self.__str__()
